package com.logicbig.example;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class NonCapturingGroupsExample {

    public static void main(String[] args) {
        showGroupInformation("pass(word)?", "password");
        //making the group non-capturing
        showGroupInformation("pass(?:word)?", "password");
    }

    public static void showGroupInformation(String regex, String input) {
        System.out.printf("Regex: %s, Input: %s%n", regex, input);
        Matcher matcher = Pattern.compile(regex).matcher(input);
        while (matcher.find()) {
            System.out.printf("Group zero, start= %s, end= %s, match= '%s'%n",
                    matcher.start(), matcher.end(), matcher.group());

            for (int i = 1; i <= matcher.groupCount(); i++) {
                System.out.printf("Group number: %s, start: %s, end: %s, match= '%s'%n%n",
                        i, matcher.start(i), matcher.end(i), matcher.group(i));
            }
        }
    }
}